------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2007-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
private with Ada.Finalization;
with Qt_Ada.Internals.Value_Class_Sizes;
with System;

package Qt4.Points is

   type Q_Point is tagged private;

   type Q_Point_Array is array (Q_Integer range <>) of Q_Point;

   function Create
    (Xpos : in Qt4.Q_Integer;
     Ypos : in Qt4.Q_Integer)
       return Q_Point;

   function Is_Null
    (Self : in Q_Point'Class)
       return Boolean;

   function Manhattan_Length
    (Self : in Q_Point'Class)
       return Qt4.Q_Integer;

   procedure Set_X
    (Self : in out Q_Point'Class;
     X : in Qt4.Q_Integer);

   procedure Set_Y
    (Self : in out Q_Point'Class;
     Y : in Qt4.Q_Integer);

   function X
    (Self : in Q_Point'Class)
       return Qt4.Q_Integer;

   function Y
    (Self : in Q_Point'Class)
       return Qt4.Q_Integer;

   function "="
    (P_1 : in Q_Point;
     P_2 : in Q_Point)
       return Boolean;

   function "+"
    (P_1 : in Q_Point;
     P_2 : in Q_Point)
       return Q_Point;

   function "-"
    (P_1 : in Q_Point;
     P_2 : in Q_Point)
       return Q_Point;

   function "*"
    (P : in Q_Point;
     S : in Qt4.Q_Real)
       return Q_Point;

   function "*"
    (S : in Qt4.Q_Real;
     P : in Q_Point)
       return Q_Point;

   function "-"
    (P_1 : in Q_Point)
       return Q_Point;

   function "/"
    (P : in Q_Point;
     S : in Qt4.Q_Real)
       return Q_Point;

   package Internals is

      type QPoint is private;

      type QPoint_Access is access all QPoint;
      pragma Convention (C, QPoint_Access);

      function QPoint_View
       (Item : in Q_Point'Class)
          return QPoint_Access;
      pragma Inline (QPoint_View);

      function To_Pointer
       (Address : in System.Address)
          return QPoint_Access;
      pragma Inline (To_Pointer);

      function To_Address
       (Pointer : in QPoint_Access)
          return System.Address;
      pragma Inline (To_Address);

      function Create_Wrapper
       (Item : in Internals.QPoint_Access)
          return Q_Point;

   private

      type QPoint is record
         Placeholder : Interfaces.C.char_array (1 .. Qt_Ada.Internals.Value_Class_Sizes.QPoint_C_Size_Of);
      end record;
      pragma Convention (C, QPoint);

   end Internals;

private

   type Q_Point is new Ada.Finalization.Controlled with record
      Storage : aliased Internals.QPoint;
      Object  : Internals.QPoint_Access := null;
      Wrapper : Boolean := False;
   end record;

   overriding
   procedure Adjust (Self : in out Q_Point);

   overriding
   procedure Finalize (Self : in out Q_Point);

   overriding
   procedure Initialize (Self : in out Q_Point);

end Qt4.Points;
